## imx-code-signing-tool 3.3.0+dfsg

=== code/cst/Makefile ===
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description:  This is the release Makefile for the CST.
#                          Builds the SIS, API library and CST executable
#                          for the selected configurations.
#
#==============================================================================
#
#             Freescale Semiconductor
#    (c) Freescale Semiconductor, Inc. 2011-2015. All rights reserved.
#    Copyright 2017-2019 NXP
#
#==============================================================================

# COMMON MAKEFILE VARIABLES
#==============================================================================
ifndef VERBOSE
.SILENT:
endif

OSTYPES := linux64 linux32 mingw32 osx

OSTYPE ?= $(word 1,$(OSTYPES))

ifeq ($(filter-out $(OSTYPE),$(OSTYPES)),$(OSTYPES))
$(error OSTYPE is not correct (expected values: $(OSTYPES)))
endif

include code/build/make/$(OSTYPE).mk

# Before including init.mk we need to set relative path to root
ROOTPATH := $(PWD)
include code/build/make/init.mk

# RELEASE SPECIFIC VARIABLE DEFINITIONS
#==============================================================================
export DST := $(PWD)/release


# OPENSSL
#===============================================================================
OPENSSL_PATH ?= $(PWD)/../openssl
export _OPENSSL_PATH := $(realpath $(OPENSSL_PATH))

OPENSSL_CONFIG += no-deprecated no-threads no-shared no-dso no-engine no-hw \
                  no-idea

# COMPONENT BUILD RULES
#==============================================================================

# Make destination directories
$(DST)%:
	$(MKDIR) $@

# release binaries for the given configuration
rel_bin: $(DST)/$(OSTYPE)/lib $(DST)/$(OSTYPE)/bin $(DST)/keys
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) rel_bin

# build binaries for the given configuration
build:
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) build

# Clean up after build
clean:
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) clean

# build openssl library
openssl:
	cd $(_OPENSSL_PATH)           && \
	./Configure $(OPENSSL_CONFIG) && \
	make clean                    && \
	make                          && \
	cp ms/applink.c include/openssl/

=== code/back_end-hsm/src/Makefile ===
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for HSM backend for CST
#
#==============================================================================
#
#    Copyright 2018-2019 NXP
#
#==============================================================================

#==============================================================================
# Compiler/Linker/Archiver Commands
#==============================================================================


ifneq ($(ARCH),)
ARCH := $(shell getconf LONG_BIT)
endif

$(info $$ARCH is [${ARCH}])

C_FLAGS_32 := -m32
C_FLAGS_64 := -m64

LD_FLAGS_32 := 
LD_FLAGS_64 := 

DESTDIR=./
PREFIX=./

STATIC=libbackend.a

CC = gcc
#CFLAGS = -Wall -Winline -pipe -I./include -I$(OPENSSL_PATH)/include

CFLAGS = $(C_FLAGS_$(ARCH)) -Wall -Wl,--export-all-symbols -w -Winline -pipe -I./include -I$(OPENSSL_PATH)/include 

LDFLAGS = -L./lib 

LIBS = -lssl -lcrypto -ldl -lpthread -lconfig

ifeq ($(OS),Windows_NT)
LIBS += -lpsapi -lgdi32
endif

SRC = backend.c config.c e_hsm.c e_hsm_err.c openssl_helper.c

OBJ = $(SRC:.c=.o)

ifeq ($(OPENSSL_PATH),)
OPENSSL_PATH := $(ROOTPATH)/../openssl
endif

# Define -mno-ms-bitfields to get correct bit-field layout of packed structs
LDFLAGS  += -I$(OPENSSL_PATH)/include -mno-ms-bitfields
LDFLAGS += -L$(OPENSSL_PATH)/lib


$(STATIC): $(OBJ)
		@echo "[Link (Static) libbackend]"
		@ar rcs $@ $^

.c.o:
		@echo [Compile] $<
		@$(CC) -c $(CFLAGS) $< -o $@

clean:
		rm -f $(OBJ) *~ core tags *.bak Makefile.bak libbackend.*

.PHONY: install
#install: $(STATIC)
#		@install -m 0755 $< $(DESTDIR)$(PREFIX)/lib

all: install
		$(CC)  $(C_FLAGS_$(ARCH)) -std=c99  -D_POSIX_C_SOURCE=200809L -Wall -Werror -g -Wall -o cst  libfrontend.a libbackend.a $(LDFLAGS) $(LIBS) -fno-builtin -fno-strict-aliasing -fno-common -DREMOVE_ENCRYPTION -Wl,--allow-multiple-definition

=== code/cst/code/obj.mingw32/Makefile ===
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================
#
#
#
#             Freescale Semiconductor
#       (c) Freescale Semiconductor, Inc. 2015. All rights reserved.
#       Copyright 2019 NXP
#
#==============================================================================

TOOLCHAIN := mingw-gcc

# Configuration-specific customization

COPTIONS += -m32
LDOPTIONS += -m32

include ../build/make/binaries.mk

=== debian/changelog ===
imx-code-signing-tool (3.3.0+dfsg-2) unstable; urgency=medium

  * Update the patch to fix more issues of the kind.
    Thanks to Peter Senna Tschudin <peter.senna@collabora.com>.
  * Add Vcs-*.
  * Add debian/gbp.conf.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 03 Feb 2020 22:11:09 +0100

imx-code-signing-tool (3.3.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #950017).

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 28 Jan 2020 12:51:44 +0100

=== debian/control ===
Source: imx-code-signing-tool
Section: electronics
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 libssl-dev,
 byacc,
 flex
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://gitlab.apertis.org/pkg/development/imx-code-signing-tool.git
Vcs-Browser: https://gitlab.apertis.org/pkg/development/imx-code-signing-tool

Package: imx-code-signing-tool
Architecture: any
Multi-Arch: foreign
Depends:
 bash,
 python3,
 python3-cryptography,
 ${misc:Depends},
 ${shlibs:Depends}
Description: code signing tool for i.MX platform
 This package provides a code signing tool for signing images
 for i.MX-based NXP processors using High Assurance Boot (HABv4)
 library in the internal boot ROM or the Advanced High Assurance
 Boot (AHAB) subsystem.
 .
 This package also provides a variety of support scripts.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	ln -sf debian/Makefile .
	ln -sf $(CURDIR)/debian/debian-toolchain.mk code/cst/code/build/make/

override_dh_installchangelogs:
	dh_installchangelogs Release_Notes.txt

override_dh_installdocs:
	dh_installdocs
	# shebang has to be the first line, *above* the copyrights
	sed -e '1 s^.*^#!/usr/bin/python3^' -i debian/*/usr/share/doc/*/*/parse_sig_blk.py
	sed -e '1 s^.*^#!/bin/bash^' -i debian/*/usr/share/doc/*/*/createSRK*
	cp code/hab_csf_parser/README $(wildcard debian/*/usr/share/doc/*)/README.csf_parser

override_dh_compress:
	dh_compress -XcreateSRK -X.py -X.sh

## imx-code-signing-tool 3.3.0+dfsg2

=== code/cst/code/obj.linux32/Makefile ===
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================
#
#
#
#             Freescale Semiconductor
#       (c) Freescale Semiconductor, Inc. 2015. All rights reserved.
#       Copyright 2019 NXP
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m32
LDOPTIONS += -m32

include ../build/make/binaries.mk

=== code/cst/code/obj.osx/Makefile ===
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for MacOS/OSX platform
#
#==============================================================================
#
#       Copyright 2019 NXP
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m64
LDOPTIONS += -m64

include ../build/make/binaries.mk

=== debian/changelog ===
imx-code-signing-tool (3.3.0+dfsg2-1) unstable; urgency=medium

  * Remove the questionably licensed and unused HSM backend
    (Closes: #985763).
  * Refresh patches.
  * Bump debhelper from old 12 to 13.
  * Remove unused license definitions.
  * Use execute_after_ instead of override_.
  * Update gbp.conf and Vcs-*.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 23 Mar 2021 09:54:12 +0100

## imx-code-signing-tool 3.3.1+dfsg

=== code/cst/Makefile ===
--- 
+++ 
@@ -55,7 +55,7 @@
 	$(MKDIR) $@
 
 # release binaries for the given configuration
-rel_bin: $(DST)/$(OSTYPE)/lib $(DST)/$(OSTYPE)/bin $(DST)/keys
+rel_bin: $(DST)/$(OSTYPE)/bin $(DST)/keys
 	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) rel_bin
 
 # build binaries for the given configuration

=== code/hab_csf_parser/Makefile ===
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for CSF parser
#
#==============================================================================
#
#    Copyright 2018-2019 NXP
#
#==============================================================================

CC = gcc

COPTS = -g -Wall -Werror
CFLAGS = -I.

DEPS = csf_parser.h extract_csf.h
SRCS = csf_parser.c extract_csf.c

.PHONY: all clean

all: csf_parser

%.o: %.c $(DEPS)
	$(CC) -c -o $@ $< $(CFLAGS)

csf_parser: csf_parser.c
	$(CC) $(COPTS) $(CFLAGS) -o $@ $(SRCS)

clean:
	rm -rvf output csf_parser

=== code/back_end-engine/src/Makefile ===
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for engine backend of CST
#
#==============================================================================
#
#    Copyright 2020 NXP
#
#==============================================================================

#==============================================================================
# Compiler/Linker/Archiver Commands
#==============================================================================

BIN := cst
LIB := libbackend.a
SRC := backend.c openssl_helper.c
DEP = -lssl -lcrypto -ldl -lpthread

BITNESS := $(shell getconf LONG_BIT)
CFLAGS_32 := -m32
CFLAGS_64 := -m64
LDFLAGS_32 := -m32
LDFLAGS_64 := -m64

CC := gcc
CFLAGS := $(CFLAGS_$(BITNESS)) -g -Wall -Werror -Winline -Wl,--export-all-symbols -Iinclude
LDFLAGS = $(LDFLAGS_$(BITNESS))

ifeq ($(OS),Windows_NT)
DEP += -lpsapi -lgdi32

CFLAGS += -mno-ms-bitfields
endif

OBJ := $(SRC:.c=.o)
ROOT := ../../..
FRONTEND := $(ROOT)/linux$(BITNESS)/lib/libfrontend.a

.PHONY: all
all: $(BIN)

.PHONY: clean
clean:
	-rm -f $(BIN) $(LIB) $(OBJ)

.PHONY: install
install: $(BIN)
	install -d $(PREFIX)/usr/bin
	install -m 0755 cst $(PREFIX)/usr/bin/

$(BIN): $(FRONTEND) $(LIB)
	$(CC) $(LDFLAGS) -o $@ $^ $(DEP)

$(LIB): $(OBJ)
	ar rcs $@ $^

.c.o:
	$(CC) -c $(CFLAGS) $< -o $@

=== code/cst/code/obj.linux64/Makefile ===
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================
#
#
#
#             Freescale Semiconductor
#       (c) Freescale Semiconductor, Inc. 2009. All rights reserved.
#       Copyright 2019 NXP
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m64
LDOPTIONS += -m64

include ../build/make/binaries.mk

=== debian/changelog ===
imx-code-signing-tool (3.3.1+dfsg-2ubuntu1) jammy; urgency=medium

  * Build without LTO, lto-disabled-list does not
    work for this package.

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 06 Jan 2022 12:44:17 +0000

imx-code-signing-tool (3.3.1+dfsg-2build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 16:35:34 +0100

imx-code-signing-tool (3.3.1+dfsg-2) unstable; urgency=medium

  * Unbreak the scripts.
    Thanks to Sean Anderson (patch taken from Arch Linux).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 12 Aug 2021 16:02:12 +0200

imx-code-signing-tool (3.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied upstream.
  * Update the copyrights.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 12 Aug 2021 15:10:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: imx-code-signing-tool
 Section: electronics
 Priority: optional
-Maintainer: Andrej Shadura <andrewsh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrej Shadura <andrewsh@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libssl-dev,
  byacc,
  flex
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
-Vcs-Git: https://gitlab.apertis.org/pkg/development/imx-code-signing-tool.git
-Vcs-Browser: https://gitlab.apertis.org/pkg/development/imx-code-signing-tool
+Vcs-Git: https://gitlab.apertis.org/pkg/imx-code-signing-tool.git -b debian/unstable
+Vcs-Browser: https://gitlab.apertis.org/pkg/imx-code-signing-tool
 
 Package: imx-code-signing-tool
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = optimize=-lto
 
 %:
 	dh $@
@@ -10,8 +12,7 @@
 override_dh_installchangelogs:
 	dh_installchangelogs Release_Notes.txt
 
-override_dh_installdocs:
-	dh_installdocs
+execute_after_dh_installdocs:
 	# shebang has to be the first line, *above* the copyrights
 	sed -e '1 s^.*^#!/usr/bin/python3^' -i debian/*/usr/share/doc/*/*/parse_sig_blk.py
 	sed -e '1 s^.*^#!/bin/bash^' -i debian/*/usr/share/doc/*/*/createSRK*

## imx-code-signing-tool 3.3.2+dfsg

=== code/cst/Makefile ===
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description:  CST Makefile that builds the CST libraries and
#                          executable.
#
#==============================================================================
#
#             Freescale Semiconductor
#    (c) Freescale Semiconductor, Inc. 2011-2015. All rights reserved.
#    Copyright 2017-2019, 2022 NXP
#
#==============================================================================

# COMMON MAKEFILE VARIABLES
#==============================================================================
ifndef VERBOSE
.SILENT:
endif

OSTYPES := linux64 linux32 mingw32 osx
OSTYPES_BUILD_ALL := $(filter-out osx,$(OSTYPES))

OSTYPE ?= $(word 1,$(OSTYPES))
ifeq ($(filter-out $(OSTYPE),$(OSTYPES)),$(OSTYPES))
$(error OSTYPE is not correct (expected values: $(OSTYPES)))
endif

include code/build/make/$(OSTYPE).mk

# Before including init.mk we need to set relative path to root
ROOTPATH := $(PWD)
include code/build/make/init.mk

# RELEASE SPECIFIC VARIABLE DEFINITIONS
#==============================================================================
export DST := $(PWD)/release

# OPENSSL
#===============================================================================
OPENSSL_PATH ?= $(PWD)/../openssl
export _OPENSSL_PATH := $(realpath $(OPENSSL_PATH))

OPENSSL_CONFIG += no-deprecated no-threads no-shared no-hw no-idea

# COMPONENT BUILD RULES
#==============================================================================
# build the complete CST package
#all:
#  # Remove osx from 'all' target
#	$(foreach ostype,$(OSTYPES_BUILD_ALL),$(MAKE) OSTYPE=$(ostype) openssl os_bin clean ;)

# Make destination directories
$(DST)%:
	$(MKDIR) $@

# Build CST binary for target OS
os_bin: $(DST)/$(OSTYPE)/bin scripts
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) rel_bin

# Build binaries for the given configuration
build:
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) build

# Copy key and certificate generation scripts
scripts: $(DST)/ca $(DST)/keys $(DST)/crts
	@echo "Copy scripts"
	$(CP) ./scripts/*.cnf $(DST)/ca
	$(CP) ./scripts/*.sh  $(DST)/keys
	$(CP) ./scripts/*.bat $(DST)/keys

# Clean up after build
clean:
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) OSTYPE=$(OSTYPE) clean

# clean up removing all build and release files
clobber:
	@echo "Clean OS objects"
	$(foreach OSTYPE, $(OSTYPES), $(MAKE) OSTYPE=$(OSTYPE) clean ;)
	@echo "Clean release"
	$(RMDIR) $(DST)/

# build openssl library
openssl:
	cd $(_OPENSSL_PATH)           && \
	./Configure $(OPENSSL_CONFIG) && \
	make clean                    && \
	make                          && \
	cp ms/applink.c include/openssl/

=== code/cst/code/obj.linux64/Makefile ===
--- 
+++ 
@@ -23,6 +23,3 @@
 LDOPTIONS += -m64
 
 include ../build/make/binaries.mk
-
-
-

=== debian/changelog ===
imx-code-signing-tool (3.3.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches:
    - Rebase script fix
    - Drop patches no longer necessary due to upstream changes
  * Add -ldl to LDLIBS just as the upstream does.
  * Update copyrights.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 12 Oct 2023 22:15:13 +0100

imx-code-signing-tool (3.3.1+dfsg-3) unstable; urgency=medium

  [ Martyn Welch ]
  * Use .o rather than weakened .a.
  * Make err_msg static so we don't get linking errors.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 20 Jun 2023 18:47:15 +0200

## imx-code-signing-tool 3.4.0+dfsg

=== Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Freescale Semiconductor
# (c) Freescale Semiconductor, Inc. 2011-2015. All rights reserved.
# Copyright 2017-2019, 2022-2023 NXP
#
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description:  CST Makefile that builds the CST libraries and
#                          executable.
#
#==============================================================================

# Define CST version number
export VERSION := 3.4.0

# Common Makefile variables
OSTYPES := linux64 linux32 mingw32 osx
OSTYPES_BUILD_ALL := $(filter-out osx,$(OSTYPES))

# Get operating system name and machine hardware name
UNAME_S := $(shell uname -s)
UNAME_M := $(shell uname -m)

# Set SYSTEM_TYPE based on the detected operating system
ifeq ($(UNAME_S),Linux)
    ifeq ($(UNAME_M),x86_64)
        SYSTEM_TYPE := linux64
    else
        SYSTEM_TYPE := linux32
    endif
endif
ifeq ($(UNAME_S),Darwin)
    SYSTEM_TYPE := osx
endif
ifeq ($(UNAME_S),MINGW32_NT-*)
    SYSTEM_TYPE := mingw32
endif

export OSTYPE ?= $(SYSTEM_TYPE)

ifeq ($(filter-out $(OSTYPE),$(OSTYPES)),$(OSTYPES))
$(error OSTYPE is not correct (expected values: $(OSTYPES)))
endif

include code/build/make/$(OSTYPE).mk

# Before including init.mk we need to set relative path to root
ROOTPATH := $(CURDIR)
include code/build/make/init.mk

# Build specific variable definitions
export O ?= $(ROOTPATH)/build

# Define the release package name with the version number
RELEASE_PACKAGE := cst-$(VERSION)

ADDONS     := $(wildcard $(ROOTPATH)/add-ons/*)
ADDONS_OUT := $(ROOTPATH)/add-ons/hab_log_parser
ADDONS_REL := $(filter-out $(ADDONS_OUT),$(ADDONS))

CSTSRC     := $(wildcard $(ROOTPATH)/code/*)
CSTSRC_OBJ := $(addprefix obj.,$(OSTYPES))
CSTSRC_OUT := $(addprefix $(ROOTPATH)/code/,$(CSTSRC_OBJ))
CSTSRC_REL := $(filter-out $(CSTSRC_OUT),$(CSTSRC))

# Build CST binary for target OS
$(O)/$(OSTYPE)/bin: openssl
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) install

# OpenSSL source and custom build paths
export OPENSSL_VERSION ?= 3.2.0
OPENSSL_TAR := openssl-$(OPENSSL_VERSION).tar.gz
OPENSSL_URL := https://www.openssl.org/source/$(OPENSSL_TAR)
OPENSSL_SRC_DIR := openssl-$(OSTYPE)
OPENSSL_BUILD_DIR := /opt/cst
OPENSSL_CONFIG += no-tests no-threads no-shared no-idea no-hw no-idea

# Check if OPENSSL_PATH is provided and valid
ifdef OPENSSL_PATH
ifeq ($(wildcard $(OPENSSL_PATH)/*),)
$(error OPENSSL_PATH is not valid)
endif
OPENSSL_LIB_DIR := $(OPENSSL_PATH)
openssl:
	@echo "Using provided OpenSSL library."
else
# Default behavior: download and build OpenSSL
OPENSSL_LIB_DIR := $(OPENSSL_SRC_DIR)

# Download and unpack OpenSSL
$(OPENSSL_TAR):
	curl -O $(OPENSSL_URL)

$(OPENSSL_SRC_DIR): $(OPENSSL_TAR)
	tar xzf $(OPENSSL_TAR)
	mv openssl-$(OPENSSL_VERSION) $(OPENSSL_SRC_DIR)

# Build OpenSSL
openssl: $(OPENSSL_SRC_DIR)
	cd $(OPENSSL_SRC_DIR) && ./Configure \
	--prefix=$(OPENSSL_BUILD_DIR) \
	--openssldir=$(OPENSSL_BUILD_DIR) $(OPENSSL_CONFIG)
	$(MAKE) -C $(OPENSSL_SRC_DIR)
	$(CP) $(OPENSSL_SRC_DIR)/ms/applink.c \
	$(OPENSSL_SRC_DIR)/include/openssl/
endif

# OPENSSL_LIB_DIR depends on conditions
$(eval export _OPENSSL_PATH := $(ROOTPATH)/$(OPENSSL_LIB_DIR))

# Make build directories
$(O)%:
	$(MKDIR) $@

# Build binaries
build: $(O)/$(OSTYPE)/bin

# Install binaries, scripts, docs and sources
install: build scripts docs sources

# Helper function to install scripts and configuration files
define install_scripts
	@for dir in scripts $(2); do \
		if [ -d $$dir ]; then \
			find $$dir -name $(1) -type f | while IFS= read -r f; do \
				echo "Installing $$f to $(O)/$(2)"; \
				case $$f in \
				*.sh|*.bat) \
					$(INSTALL) -D -m 0755 "$$f" $(O)/$(2) ;; \
					*) \
					$(CP) "$$f" $(O)/$(2) ;; \
				esac; \
			done; \
		fi; \
	done
endef

# Copy key and certificate generation scripts
scripts: $(O)/ca $(O)/keys $(O)/crts
	@echo "Copy scripts and configuration files"
	$(call install_scripts,*.cnf,ca)
	$(call install_scripts,*.sh,keys)
	$(call install_scripts,*.bat,keys)

# Clean-up after build
clean:
	@echo "Clean-up build objects"
	$(MAKE) -C $(CST_CODE_PATH)/obj.$(OSTYPE) OSTYPE=$(OSTYPE) clean

# Clean-up removing all build output files
clobber:
	@echo "Clean OS objects"
	$(foreach OSTYPE, $(OSTYPES), $(MAKE) OSTYPE=$(OSTYPE) clean ;)
	@echo "Clean build"
	$(RMDIR) $(O)/

# Clean-up the repository by removing untracked files and directories
distclean:
	git clean -dfx

# Copy documentation to output folder
docs: $(O)/docs
	@echo "Copy documentations"
	$(CP_REC) $(shell find docs -name '*.pdf' -o -name '*.md') $(O)/docs
	$(CP_REC) ./Release_Notes.txt  $(O)/
	$(CP_REC) ./BUILD.md           $(O)/
	$(CP_REC) ./LICENSE.openssl    $(O)/
	$(CP_REC) ./LICENSE.bsd3       $(O)/
	@if [ -d "$(ROOTPATH)/add-ons/hab_log_parser" ]; then \
		$(CP_REC) $(ROOTPATH)/add-ons/hab_log_parser/README \
					$(O)/docs/README.hab_log_parser; \
		$(CP_REC) $(ROOTPATH)/add-ons/hab_log_parser/LICENSE.hidapi $(O)/; \
	else \
		echo "Skipping hab_log_parser."; \
	fi
	$(CP_REC) ./Software_Content_Register_CST.txt $(O)/

# Copy source and header directories to output folder
sources: $(addprefix $(O)/code/,$(CSTSRC_OBJ))
	@echo "Copy sources"
	$(CP_REC) Makefile \
	          $(O)/
	$(CP_REC) Dockerfile \
	          $(O)/
	$(CP_REC) Dockerfile.hsm \
	          $(O)/
	$(CP_REC) $(CSTSRC_REL) \
	          $(O)/code/
	$(MKDIR)  $(O)/add-ons/
	$(CP_REC) $(ADDONS_REL) \
	          $(O)/add-ons/
	$(foreach objdir,$(CSTSRC_OBJ), $(MKDIR) $(O)/code/$(objdir); \
		$(CP_REC) $(CST_CODE_PATH)/$(objdir)/Makefile $(O)/code/$(objdir)/ ;)

# Build and the images for all OS targets except OSX. The Docker build
# environment doesn't include cross compile tools for OSX.
build-all:
	$(foreach ostype,$(OSTYPES_BUILD_ALL),$(MAKE) OSTYPE=$(ostype) ;)

install-all:
	$(foreach ostype,$(OSTYPES_BUILD_ALL),$(MAKE) OSTYPE=$(ostype) install ;)

# Sequentially execute build and install for all supported systems,
# then install scripts documentation and source code.
all: build-all install-all scripts docs sources

# Create a package of the build directory
package: all
	@echo "Creating package version $(VERSION)"
	ln -sfn $(O) $(RELEASE_PACKAGE)
	tar -czvf $(RELEASE_PACKAGE).tgz \
	--transform='s,^$(notdir $(O)),$(RELEASE_PACKAGE),' $(notdir $(O))
	@echo "Package file $(RELEASE_PACKAGE).tgz created."

.PHONY: all build-all install-all scripts docs sources package

=== code/obj.linux64/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Freescale Semiconductor
# (c) Freescale Semiconductor, Inc. 2009. All rights reserved.
# Copyright 2019, 2023 NXP
#
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m64
LDOPTIONS += -m64

include ../build/make/binaries.mk

=== debian/changelog ===
imx-code-signing-tool (3.4.0+dfsg-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:56:05 +1100

imx-code-signing-tool (3.4.0+dfsg-2build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:14:58 +0000

imx-code-signing-tool (3.4.0+dfsg-2) unstable; urgency=medium

  * Remove upstream Makefile before running dh_auto_clean.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 18 Jan 2024 15:48:27 +0100

imx-code-signing-tool (3.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Adjust paths according to the upstream changes.
  * Update Vcs-Browser to point to the actual branch.
  * Update the copyrights.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 18 Jan 2024 14:24:18 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Vcs-Git: https://gitlab.apertis.org/pkg/imx-code-signing-tool.git -b debian/unstable
-Vcs-Browser: https://gitlab.apertis.org/pkg/imx-code-signing-tool
+Vcs-Browser: https://gitlab.apertis.org/pkg/imx-code-signing-tool/-/tree/debian/unstable
 
 Package: imx-code-signing-tool
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	ln -sf debian/Makefile .
	ln -sf $(CURDIR)/debian/debian-toolchain.mk code/build/make/

override_dh_installchangelogs:
	dh_installchangelogs Release_Notes.txt

execute_after_dh_installdocs:
	# shebang has to be the first line, *above* the copyrights
	sed -e '1 s^.*^#!/usr/bin/python3^' -i debian/*/usr/share/doc/*/*/parse_sig_blk.py
	sed -e '1 s^.*^#!/bin/bash^' -i debian/*/usr/share/doc/*/*/createSRK*
	cp add-ons/hab_csf_parser/README $(wildcard debian/*/usr/share/doc/*)/README.csf_parser

override_dh_compress:
	dh_compress -XcreateSRK -X.py -X.sh

execute_before_dh_auto_clean:
	rm -f Makefile

## imx-code-signing-tool 3.4.1%2Bdfsg

=== code/obj.linux32/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Freescale Semiconductor
# (c) Freescale Semiconductor, Inc. 2015. All rights reserved.
# Copyright 2019, 2023 NXP
#
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m32
LDOPTIONS += -m32

include ../build/make/binaries.mk

## imx-code-signing-tool 3.4.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Freescale Semiconductor
 # (c) Freescale Semiconductor, Inc. 2011-2015. All rights reserved.
-# Copyright 2017-2019, 2022-2023 NXP
+# Copyright 2017-2019, 2022-2024 NXP
 #
 #==============================================================================
 #
@@ -14,7 +14,7 @@
 #==============================================================================
 
 # Define CST version number
-export VERSION := 3.4.0
+export VERSION := 3.4.1
 
 # Common Makefile variables
 OSTYPES := linux64 linux32 mingw32 osx
@@ -92,7 +92,7 @@
 
 # Download and unpack OpenSSL
 $(OPENSSL_TAR):
-	curl -O $(OPENSSL_URL)
+	curl --proxy-insecure --insecure -O $(OPENSSL_URL)
 
 $(OPENSSL_SRC_DIR): $(OPENSSL_TAR)
 	tar xzf $(OPENSSL_TAR)

=== add-ons/hab_csf_parser/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright 2018-2019, 2023 NXP
#
#==============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for CSF parser
#
#==============================================================================

CC = gcc

COPTS = -g -Wall -Werror
CFLAGS = -I.

DEPS = csf_parser.h extract_csf.h
SRCS = csf_parser.c extract_csf.c

.PHONY: all clean

all: csf_parser

%.o: %.c $(DEPS)
	$(CC) -c -o $@ $< $(CFLAGS)

csf_parser: csf_parser.c
	$(CC) $(COPTS) $(CFLAGS) -o $@ $(SRCS)

clean:
	rm -rvf output csf_parser

=== code/obj.mingw32/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Freescale Semiconductor
# (c) Freescale Semiconductor, Inc. 2015. All rights reserved.
# Copyright 2019, 2023 NXP
#
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for ARM Cortex-A8 little endian
#                         configuration
#
#==============================================================================

TOOLCHAIN := mingw-gcc

# Configuration-specific customization

COPTIONS += -m32
LDOPTIONS += -m32

include ../build/make/binaries.mk

=== code/obj.osx/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright 2019, 2023 NXP
#
#=============================================================================
#
#    File Name:  Makefile
#
#    General Description: Makefile for MacOS/OSX platform
#
#==============================================================================

TOOLCHAIN := gcc

# Configuration-specific customization

COPTIONS += -m64
LDOPTIONS += -m64

include ../build/make/binaries.mk

=== debian/changelog ===
imx-code-signing-tool (3.4.1+dfsg-6) unstable; urgency=medium

  * Add manpages.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 04 Jun 2025 09:09:10 +0200

imx-code-signing-tool (3.4.1+dfsg-5) unstable; urgency=medium

  * Unbreak build on big endian platforms by reusing ntohl instead of from_be32.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Jun 2025 17:22:04 +0200

imx-code-signing-tool (3.4.1+dfsg-4) unstable; urgency=medium

  * preinst:
    - Verify the source is not already a symlink.
    - Don’t run migrations needlessly.
  * Pass LDFLAGS when building csf_parser.
  * createSRKTable: Remove commented out lines resulting in incorrect shell
    syntax.
  * Enable all hardening options.
  * Standards-Version: 4.7.2.
  * Silence bash warning by depending on bash 4.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Jun 2025 15:05:18 +0200

imx-code-signing-tool (3.4.1+dfsg-3) unstable; urgency=medium

  * Fix upgrade path from previous versions.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Jun 2025 13:52:00 +0200

imx-code-signing-tool (3.4.1+dfsg-2) unstable; urgency=medium

  * Move Vcs-* to Salsa.
  * Update standards version to 4.6.2, no changes needed.
  * Set Collabora team as the maintainer.
  * Add missing dependencies for the PKI scripts.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 02 Jun 2025 15:31:14 +0200

imx-code-signing-tool (3.4.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Clean the source during clean stage if Makefile’s still there.
  * Install the new binary mac_dump.
  * Update unbreak-scripts.patch to cover more scripts.
  * Install "ca" directory with openssl configuration.
  * Install scripts into libexec.
  * Add autopkgtests.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 02 Jun 2025 14:00:25 +0200

=== debian/control ===
Source: imx-code-signing-tool
Section: electronics
Priority: optional
Maintainer: Collabora Team <team+collabora@tracker.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libssl-dev,
 byacc,
 flex
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/collabora-team/imx-code-signing-tool.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/collabora-team/imx-code-signing-tool/-/tree/debian/unstable

Package: imx-code-signing-tool
Architecture: any
Multi-Arch: foreign
Depends:
 bash (>= 4.0),
 openssl,
 opensc,
 python3,
 python3-cryptography,
 ${misc:Depends},
 ${shlibs:Depends}
Description: code signing tool for i.MX platform
 This package provides a code signing tool for signing images
 for i.MX-based NXP processors using High Assurance Boot (HABv4)
 library in the internal boot ROM or the Advanced High Assurance
 Boot (AHAB) subsystem.
 .
 This package also provides a variety of support scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

debian/%.1: debian/%.pod
	pod2man -r "" -c "i.MX CST Documentation" -n $(shell echo $(notdir $(@:%.1=%)) | tr a-z A-Z) $< > $@

execute_before_dh_installman: debian/cst.1 debian/srktool.1 debian/csf_parser.1

override_dh_auto_configure:
	ln -sf debian/Makefile .
	ln -sf $(CURDIR)/debian/debian-toolchain.mk code/build/make/

override_dh_installchangelogs:
	dh_installchangelogs Release_Notes.txt

execute_after_dh_install:
	# shebang has to be the first line, *above* the copyrights
	sed -e '1 s^.*^#!/usr/bin/python3^' -i debian/*/usr/share/libexec/*/*/parse_sig_blk.py
	sed -e '1 s^.*^#!/bin/bash^' -i debian/*/usr/share/libexec/*/*/createSRK*
	chmod +x debian/*/usr/share/libexec/*/pki_scripts/*.sh

execute_after_dh_installdocs:
	cp add-ons/hab_csf_parser/README $(wildcard debian/*/usr/share/doc/*)/README.csf_parser

override_dh_compress:
	dh_compress -XcreateSRK -X.py -X.sh

execute_before_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f Makefile

=== debian/tests/control ===
Tests: smoke
Restrictions: allow-stderr, superficial

Tests: create-csf
Restrictions: allow-stderr

## imx-code-signing-tool 4.0.1%2Bdfsg

=== src/lib/CMakeLists.txt ===
include_directories(common)
include_directories(back_end)
include_directories(front_end)

add_subdirectory(common)
add_subdirectory(back_end)
add_subdirectory(front_end)

=== src/tools/cst/CMakeLists.txt ===
add_executable(cst
    cst.c
)

target_link_libraries(cst PRIVATE
    CST::front_end
    CST::back_end
    ${CMAKE_DL_LIBS}
)

install(TARGETS cst 
    EXPORT ${PROJECT_NAME} 
    DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/tools/srktool/CMakeLists.txt ===
add_executable(srktool
    srktool.c
)

target_link_libraries(srktool PRIVATE
    CST::front_end
    CST::back_end
    ${CMAKE_DL_LIBS}
)

install(TARGETS srktool 
    EXPORT ${PROJECT_NAME}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,18 @@
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>,
 Build-Depends:
+ bison,
+ cmake,
  debhelper-compat (= 13),
+ dh-exec,
+ flex,
+ libhidapi-dev,
+ libjson-c-dev,
  libssl-dev,
- byacc,
- flex
+ libudev-dev,
+ libusb-1.0-0-dev,
+ openssl,
+ pkgconf
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/collabora-team/imx-code-signing-tool.git -b debian/unstable
@@ -25,6 +33,9 @@
  python3-cryptography,
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends:
+ libengine-pkcs11-openssl,
+ p11-kit
 Description: code signing tool for i.MX platform
  This package provides a code signing tool for signing images
  for i.MX-based NXP processors using High Assurance Boot (HABv4)

=== debian/tests/control ===
--- 
+++ 
@@ -3,3 +3,7 @@
 
 Tests: create-csf
 Restrictions: allow-stderr
+
+Tests: hsm-sign
+Depends: @, libengine-pkcs11-openssl, opensc, p11-kit, softhsm2, libsofthsm2, util-linux-extra
+Restrictions: allow-stderr, needs-sudo
